import java.util.HashSet;
import java.util.Set;
import edu.rit.m2mi.M2MI;
public class CellPhone implements Phone {
	private Phone handle; // core
	private Set<Callbackable> callback; // r2
	private String location; // r3
	public CellPhone(String location_) { // core
		handle = (Phone) M2MI.getUnihandle(this, Phone.class); //core
		callback = new HashSet<Callbackable>(); //core
		location = location_; 	} //core
	public void ping(Device d) { // r2
		d.pong(handle); 	}// r2
	public void pong(Device d) {	} // r2
	public void getLocation(Callbackable c) { // r3
		c.respondLocation(handle, location);	} // r3
	public void registerCallback(Callbackable c) { // r2
		synchronized (callback) { // r2
			callback.add(c);		} 	} // r2
	public void call(String number) { //core  
		System.out.println("Incoming call from " + number); // core
		Set<Callbackable> snapshot; //core
		synchronized (callback) { // core
			snapshot = new HashSet<Callbackable>(callback); 		} //core
		Set<Callbackable> toDelete = new HashSet<Callbackable>();// r2
		for (Callbackable c : snapshot) { //r2
			try {// r2
				c.incomingCall(number); //core
			} catch (Exception e) {// r2
				toDelete.add(c); } }// r2 
		synchronized (callback) { //core
			for (Callbackable c : toDelete) // r2
				callback.remove(c); } } // r2
	public static void main(String[] args) { //core
		M2MI.initialize(); // r2
		CellPhone cellphone = new CellPhone("roomA"); // r2
		M2MI.export(cellphone, Phone.class); // r2
		while (true) {
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				e.printStackTrace(); } } } }