import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import edu.rit.m2mi.Handle;
import edu.rit.m2mi.M2MI;
import edu.rit.m2mi.Omnihandle;
public class Contract implements Callbackable {
	private Map<AudioDevice,String> devices; // 1,2,3
	private Handle handle; // overhead
	private Phone phone; // 2 
	private String phone_location; // 3
	public Contract() { // overhead == 1
		handle = M2MI.getUnihandle(this, Callbackable.class); // overhead
		devices = new HashMap<AudioDevice, String>(); } // overhead
	public void ping(Device d) { } // overhead == 1
	public void pong(Device d) { // r2
		d.getLocation((Callbackable) handle); } // r2
	public void respondLocation(Device d, String location) { // r2
		if (d instanceof Phone) { // r2
			phone = (Phone) d; //  r2
			phone_location = location; //r3
			phone.registerCallback((Callbackable) handle); // r2
		} else if (d instanceof AudioDevice) { // r2
			synchronized (devices) { // 2,3
				devices.put((AudioDevice) d,location); } } }//r3
	public void getLocation(Callbackable c) { } // overhead == 
	public void incomingCall(String number) { // core
		System.out.println("Responding to incoming call on phone " + phone + " from " + number); //core
		Set<AudioDevice> snapshot = new HashSet<AudioDevice>();  // core
		synchronized (devices) { // r3
			for ( AudioDevice d : devices.keySet()) // r3
				if (devices.get(d).equals(phone_location)) //r3
					snapshot.add(d); }//r3
		Set<AudioDevice> toDelete = new HashSet<AudioDevice>();// r2
		for (AudioDevice d : snapshot) // core
			try {// r2
				d.pause(); //core
			} catch (Exception e) {// r2
				toDelete.add(d);// r2
			} synchronized (devices) { // r2
			for (AudioDevice d : toDelete) // r2
				devices.remove(d); } } // r2
	private void discoverDevices() { // r2
		Omnihandle omnihandle = M2MI.getOmnihandle(Device.class); // r2
		((Device) omnihandle).ping((Device) handle); } // r2
	public static void main(String[] args) { //overhead
		M2MI.initialize(); //r2
		Contract contract = new Contract(); //overhead
		M2MI.export(contract, Device.class); //r2
		while (true) { // r2
			try { // r2
				contract.discoverDevices(); // r2
				Thread.sleep(2000); // r2
			} catch (InterruptedException e) { // r2
				e.printStackTrace(); } } } } //r2